package ru.cleptoman.flv.utils {
	import flash.display.BitmapData;
	import flash.geom.Point;
	import flash.utils.ByteArray;
	/**
	 * ...
	 * @author Aleksey Kutov aka cleptoman
	 */
	public class ScreenVideoPacket {
		
		public static function calculate(frameType:uint,blockWidth:uint, width:uint, blockHeight:uint, height:uint, image:BitmapData):ByteArray {
			var packet:ByteArray				= new ByteArray();
			var byte:uint					= 3;
			byte							|= frameType << 4;
			packet.writeByte(byte);
			BytesUtils.writeUnsignedBytes4And12(packet, int(blockWidth / 16) - 1, width);
			BytesUtils.writeUnsignedBytes4And12(packet, int(blockHeight / 16) - 1, height);
			
			var fullRows:uint		= int(height / blockHeight);
			var lastRowHeight:uint	= height % blockHeight;
			fullRows				+= (lastRowHeight > 0) ? 1 : 0;
			//trace("fullRows: " +fullRows + ", lastRowHeight: " + lastRowHeight);
			
			var fullCols:uint		= int(width / blockWidth);
			var lastColWidth:uint	= width % blockWidth;
			fullCols				+= (lastColWidth > 0) ? 1 : 0;
			//trace("fullCols: " +fullCols + ", lastColWidth: " + lastColWidth);
			
			var row:uint;
			var col:uint;
			
			var block:ByteArray;
			
			var blockRow:uint;
			var blockCol:uint;
			
			var currBlockHeight:uint;
			var currBlockWidth:uint;
			
			var pixel:Point;
			var videoPoint:uint;
			
			for (row = 0; row < fullRows; row++ ) {
				for (col = 0; col < fullCols; col++ ) {
					block				= new ByteArray();
					currBlockHeight	= (lastRowHeight > 0 && row == fullRows - 1) ? lastRowHeight : blockHeight;
					for (blockRow = 0; blockRow < currBlockHeight; blockRow++ ) {
						currBlockWidth	= (lastColWidth > 0 && col == fullCols - 1) ? lastColWidth : blockWidth;
						for (blockCol = 0; blockCol < currBlockWidth; blockCol++ ) {
							pixel		= new Point(col * blockWidth + blockCol, height - ((row * blockHeight) + blockRow));
							videoPoint 	= image.getPixel(pixel.x, pixel.y);
							block.writeByte( videoPoint & 0xff );
							block.writeByte( videoPoint >> 8 & 0xff );
							block.writeByte( videoPoint >> 16 );
						}
					}
					block.compress();
					BytesUtils.writeUnsignedInt16(packet, block.length);
					packet.writeBytes( block );
				}
			}
			return packet;
			
		}
		
	}

}